# -*- coding: utf-8 -*-
"""
/***************************************************************************
A QGIS plugin
 Vallaris
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
        begin                : 2021
        copyright            : i-bitz 2021
        email                : sales@i-bitz.co.th
***************************************************************************/
"""

import tempfile,os,json
from qgis.PyQt.QtWidgets import *
from PyQt5 import QtCore
from PyQt5 import QtGui

class ManagerDialog:
    def __init__(self,dlg,iface,apikey=None):
        
        self.iface = iface
        self.dlg_logins = dlg[0]
        self.dlg_main = dlg[1]
        self.dlg_features = dlg[2]
        self.dlg_new_collection = dlg[3]
        self.dlg_new_tile = dlg[4]  
        self.dlg_manage_user = dlg[5] 
        self.dlg_style = dlg[6]  
        self.apikey = apikey

        self.temp_path = tempfile.gettempdir() 
        # self.Vallaris_temp_path = self.temp_path+"/vallaris" 
        self.nowDialog_path = self.temp_path+"/nowDialog.json"  

        self.dlg_new_tile.checkBox_cluster.toggled.connect(self.cluster) 
        self.dlg_logins.eye.clicked.connect(self.password_eye)  

        self.password_mode = "Password"
        icon  = QtGui.QPixmap('../img/invisible.png')
        self.dlg_logins.eye.setIcon(QtGui.QIcon(icon))   
      

    def manager_dialog(self,nowDialog = None):

        if self.apikey == None: 
            if nowDialog == self.dlg_manage_user:
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close()  
                self.dlg_style.close() 
                self.center(self.dlg_manage_user)   
                self.dlg_manage_user.show()                 
                self.writeNowDialog("dlg_manage_user",self.apikey) 
            else:
                nowDialog = self.dlg_logins

        if nowDialog != None:
            if nowDialog == self.dlg_logins:
                self.password_mode = "Normal"
                self.password_eye()
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close() 
                self.dlg_style.close() 
                self.center(self.dlg_logins) 
                self.dlg_logins.show()                                        
                self.writeNowDialog("dlg_logins",self.apikey) 
            if nowDialog == self.dlg_main:
                self.dlg_main.setMinimumSize(400,250)
                self.dlg_main.setMaximumSize(400,250)                           
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close() 
                self.dlg_manage_user.close() 
                self.dlg_style.close() 
                self.center(self.dlg_main)    
                self.dlg_main.show()                 
                self.writeNowDialog("dlg_main",self.apikey) 
            if nowDialog == self.dlg_features:
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close() 
                self.dlg_style.close() 
                self.center(self.dlg_features)                  
                self.dlg_features.show()                                
                self.writeNowDialog("dlg_collection",self.apikey)
                if self.dlg_features.datetime.isCollapsed() == True:  
                    self.dlg_features.extent.setCollapsed(False)   
                    self.dlg_features.extent.setChecked(False)   
                self.dlg_features.properties.setCollapsed(True)   
                self.dlg_features.properties.setChecked(False) 
                self.dlg_features.datetime.setCollapsed(True)   
                self.dlg_features.datetime.setChecked(False)                  
                
                # self.dlg_features.setMinimumSize(430, self.dlg_features.height()+40)  
                # self.dlg_features.setMaximumSize(430, self.dlg_features.height()+40)                      

            if nowDialog == self.dlg_new_collection:
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close() 
                self.dlg_manage_user.close() 
                self.dlg_style.close() 
                self.center(self.dlg_new_collection)   
                self.dlg_new_collection.setMinimumSize(415,450)
                self.dlg_new_collection.setMaximumSize(415,450)                    
                self.dlg_new_collection.show()                 
                self.writeNowDialog("dlg_new_collection",self.apikey)
            if nowDialog == self.dlg_new_tile:
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close() 
                self.dlg_style.close()  
                self.center(self.dlg_new_tile)   
                self.dlg_new_tile.show()                 
                self.writeNowDialog("dlg_new_tile",self.apikey) 

            if nowDialog == self.dlg_manage_user:

                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close()  
                self.dlg_style.close() 
                self.center(self.dlg_manage_user)   
                self.dlg_manage_user.show()                 
                self.writeNowDialog("dlg_manage_user",self.apikey) 
            if nowDialog == self.dlg_style:
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close()  
                self.dlg_style.close() 
                self.center(self.dlg_style)   
                self.dlg_style.setMinimumSize(450,460)
                self.dlg_style.setMaximumSize(450,460)   
                self.dlg_style.show() 
                self.writeNowDialog("dlg_style",self.apikey) 
                                                                                             
        else:
            
            if not os.path.isfile(self.nowDialog_path):
                with open(self.nowDialog_path, 'w') as f:
                    json_data = {"nowDialog": "dlg_logins"}
                    json.dump(json_data, f)   
            if self.ReadNowDialog() == "dlg_logins":
                self.password_mode = "Normal"
                self.password_eye()
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()
                self.dlg_manage_user.close()   
                self.center(self.dlg_logins)  
                self.dlg_logins.show()    
                                        
            if self.ReadNowDialog() == "dlg_main":
                self.dlg_main.setMinimumSize(400,250)
                self.dlg_main.setMaximumSize(400,250)
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close() 
                self.dlg_manage_user.close()   
                self.center(self.dlg_main)   
                self.dlg_main.show()                 

            if self.ReadNowDialog() == "dlg_collection":
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close() 
                self.center(self.dlg_features)  
                self.dlg_features.show() 
                                

            if self.ReadNowDialog() == "dlg_new_collection":
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close()  
                self.dlg_manage_user.close()  
                self.center(self.dlg_new_collection) 
                self.dlg_new_collection.setMinimumSize(415,450)
                self.dlg_new_collection.setMaximumSize(415,450)                     
                self.dlg_new_collection.show()                 

            if self.ReadNowDialog() == "dlg_new_tile":
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close() 
                self.dlg_manage_user.close() 
                self.center(self.dlg_new_tile)    
                self.dlg_new_tile.show() 

            if self.ReadNowDialog() == "dlg_manage_user":
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close() 
                self.dlg_manage_user.close() 
                self.center(self.dlg_new_tile)    
                self.dlg_manage_user.show()   

            if self.ReadNowDialog() == "dlg_style":
                self.dlg_logins.close()
                self.dlg_main.close()        
                self.dlg_features.close() 
                self.dlg_new_collection.close() 
                self.dlg_new_tile.close() 
                self.dlg_manage_user.close() 
                self.dlg_style.close()  
                self.dlg_style.setMinimumSize(450,440)
                self.dlg_style.setMaximumSize(450,440)    
                self.center(self.dlg_style)    
                self.dlg_style.show()                                 


    def writeNowDialog(self,data,apikey=None):
        json_data = {"nowDialog": data,"apikey":apikey}
        with open(self.nowDialog_path, 'w') as f:
            # print(json_data)
            json.dump(json_data, f) 


    def ReadNowDialog(self):  
        with open(self.nowDialog_path, encoding='utf-8') as fh:
            data = json.load(fh)             
        return data["nowDialog"]  


    def center(self,dlg):
        screen = QDesktopWidget().screenGeometry()
        widget = dlg.geometry()
        x = screen.width() - widget.width()
        y = screen.height() - widget.height()
        dlg.move((x/2), (y/2))
        dlg.setWindowState(QtCore.Qt.WindowActive)      

    def cluster(self):
        if self.dlg_new_tile.checkBox_cluster.isChecked():
            self.dlg_new_tile.cluster_pixel.setDisabled(False) 
            self.dlg_new_tile.cluster_unit.setDisabled(False)  
        else:
            self.dlg_new_tile.cluster_pixel.setDisabled(True) 
            self.dlg_new_tile.cluster_unit.setDisabled(True)    



    def password_eye(self):
        if self.password_mode == "Password":
            icon  = QtGui.QPixmap('../img/eye.png')              
            self.dlg_logins.eye.setIcon(QtGui.QIcon(icon))
            self.dlg_logins.password.setEchoMode(QLineEdit.EchoMode.Normal)            
            self.password_mode = "Normal"
        else:
            icon  = QtGui.QPixmap('../img/invisible.png')          
            self.dlg_logins.eye.setIcon(QtGui.QIcon(icon))            
            self.dlg_logins.password.setEchoMode(QLineEdit.EchoMode.Password)   
            self.password_mode = "Password"         
            


